package com.hindigk.gkhindiquiz.hindiquiz.SqliteDatabaseHelper;

/**
 * Created by Lenovo on 08/04/2017.
 */

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteException;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

import com.hindigk.gkhindiquiz.hindiquiz.model.AllDBDataModel;
import com.hindigk.gkhindiquiz.hindiquiz.utils.Constants;

public class DatabaseHelper extends SQLiteOpenHelper {

    // Logcat tag
    private static final String LOG = DatabaseHelper.class.getName();

    // Database Version
    private static final int DATABASE_VERSION = 1;

    // Database Name
    //private static String DATABASE_NAME = "kbcsport.sqlite";

    // Table Names
    private static final String TABLE_HINDI_QUESTION = "HindiQuestion";

    // Common column names
    private static final String KEY_ID = "QuestionID";
    private static final String KEY_QUESTION_NAME = "QuestionName";
    private static final String KEY_OPTIONA = "OptionA";
    private static final String KEY_OPTIONB = "OptionB";
    private static final String KEY_OPTIONC = "OptionC";
    private static final String KEY_OPTIOND = "OptionD";
    private static final String KEY_ANSWER = "Answer";

    private Context mycontext;
    private static String DB_PATH ="/data/data/com.hindigk.gkhindiquiz.hindiquiz/databases/";
    public SQLiteDatabase myDataBase;

    public DatabaseHelper(Context context, String dbName) throws IOException {
        super(context, Constants.DATABASE_NAME,null,DATABASE_VERSION);

        //Constants.DATABASE_NAME = dbName;

        this.mycontext=context;
        boolean dbexist = checkdatabase();
        if (dbexist) {
            Log.e("Database exists"," oo  ");
            opendatabase();
        } else {
            Log.e("Database doesn't exist", " oo");
            createdatabase();
        }
    }

    public void createdatabase() throws IOException {
        boolean dbexist = checkdatabase();
        if(dbexist) {
            Log.e(" Database exists.","  ooo");
        } else {
            this.getReadableDatabase();
            try {
                copydatabase();
            } catch(IOException e) {
                throw new RuntimeException(e);
                //throw new Error("Error copying database");
            }
        }
    }

    private boolean checkdatabase() {

        boolean checkdb = false;
        try {
            String myPath = DB_PATH + Constants.DATABASE_NAME;
            File dbfile = new File(myPath);
            checkdb = dbfile.exists();
        } catch(SQLiteException e) {
            Log.e("Database doesn't exist", "  p p");
        }
        return checkdb;
    }

    private void copydatabase() throws IOException {
        //Open your local db as the input stream
        InputStream myinput = mycontext.getAssets().open(Constants.DATABASE_NAME);

        // Path to the just created empty db
        String outfilename = DB_PATH + Constants.DATABASE_NAME;

        //Open the empty db as the output stream
        OutputStream myoutput = new FileOutputStream(outfilename);

        // transfer byte to inputfile to outputfile
        byte[] buffer = new byte[1024];
        int length;
        while ((length = myinput.read(buffer))>0) {
            myoutput.write(buffer,0,length);
        }

        //Close the streams
        myoutput.flush();
        myoutput.close();
        myinput.close();
    }

    public void opendatabase() throws SQLException {
        //Open the database
        String mypath = DB_PATH + Constants.DATABASE_NAME;
        myDataBase = SQLiteDatabase.openDatabase(mypath, null, SQLiteDatabase.OPEN_READWRITE);
    }

    public synchronized void close() {
        if(myDataBase != null) {
            myDataBase.close();
        }
        super.close();
    }


//    public DatabaseHelper(Context context) {
//        super(context, DATABASE_NAME, null, DATABASE_VERSION);
//    }

    @Override
    public void onCreate(SQLiteDatabase db) {

    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        // on upgrade drop older tables
        // create new tables
        //onCreate(db);
    }

    /**
     * getting all todos
     * */
    public List<AllDBDataModel> getAllQuestions() {
        List<AllDBDataModel> todos = new ArrayList<AllDBDataModel>();
        String selectQuery = "SELECT  * FROM " + TABLE_HINDI_QUESTION;

        Log.e(LOG, selectQuery);

        myDataBase = this.getReadableDatabase();
        Cursor c = myDataBase.rawQuery(selectQuery, null);

        // looping through all rows and adding to list
        if (c.moveToFirst()) {
            do {
                AllDBDataModel td = new AllDBDataModel();
                td.setId(c.getInt((c.getColumnIndex(KEY_ID))));
                td.setQuestionName((c.getString(c.getColumnIndex(KEY_QUESTION_NAME))));
                td.setOptionA(c.getString(c.getColumnIndex(KEY_OPTIONA)));
                td.setOptionB(c.getString(c.getColumnIndex(KEY_OPTIONB)));
                td.setOptionC(c.getString(c.getColumnIndex(KEY_OPTIONC)));
                td.setOptionD(c.getString(c.getColumnIndex(KEY_OPTIOND)));
                td.setAnswer(c.getString(c.getColumnIndex(KEY_ANSWER)));

                // adding to todo list
                todos.add(td);
            } while (c.moveToNext());
        }

        return todos;
    }
}
