package com.hindigk.gkhindiquiz.hindiquiz.activities;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.view.View;

import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.ads.InterstitialAd;
import com.hindigk.gkhindiquiz.hindiquiz.R;
import com.hindigk.gkhindiquiz.hindiquiz.adapter.CategoryListAdapter;

public class HomeActivity extends AppCompatActivity {


    public static AdRequest fullAdRequest;
    public static InterstitialAd mInterstitialAd;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_home);

        RecyclerView recyclerView = (RecyclerView) findViewById(R.id.activity_home_recyclerview);
        recyclerView.setHasFixedSize(true);

        LinearLayoutManager layoutManager = new LinearLayoutManager(HomeActivity.this);
        recyclerView.setLayoutManager(layoutManager);

        CategoryListAdapter matchAdapter = new CategoryListAdapter(HomeActivity.this, true, 99);
        recyclerView.setAdapter(matchAdapter);


        AdView mAdView = (AdView) findViewById(R.id.activity_home_adview);
        AdRequest adRequest = new AdRequest.Builder()
                //.addTestDevice("1432DF9EDEE25FAADA98CE2D4BE04650")
                .addTestDevice("1432DF9EDEE25FAADA98CE2D4BE04650")
                .build();
        mAdView.loadAd(adRequest);



        mInterstitialAd = new InterstitialAd(this);

        // set the ad unit ID
        mInterstitialAd.setAdUnitId(getString(R.string.interstitial_full_screen));

        fullAdRequest = new AdRequest.Builder()
                //.addTestDevice("7C040B7AA34D588990089FB90E4380CC")
                //.addTestDevice("1432DF9EDEE25FAADA98CE2D4BE04650")
                .build();

        mInterstitialAd.setAdListener(new AdListener() {
            public void onAdLoaded() {
                showInterstitial();
            }
        });

    }

    private void showInterstitial() {
        if (mInterstitialAd.isLoaded()) {
            mInterstitialAd.show();
        }
    }
}
