package com.hindigk.gkhindiquiz.hindiquiz.adapter;

import android.content.Context;
import android.content.Intent;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.hindigk.gkhindiquiz.hindiquiz.R;
import com.hindigk.gkhindiquiz.hindiquiz.activities.ChildCategoryListActivity;
import com.hindigk.gkhindiquiz.hindiquiz.activities.QuestionAnswerActivity;
import com.hindigk.gkhindiquiz.hindiquiz.utils.Constants;

public class CategoryListAdapter extends RecyclerView.Adapter<CategoryListAdapter.Holder> {

    private Context context;
    private boolean isFromHomeActivity = false;
    private String[] categoryArray;
    private int isFromIndex;

    public CategoryListAdapter(Context context, boolean isFromHomeActivity, int isFromIndex) {
        this.context = context;
        this.isFromHomeActivity = isFromHomeActivity;

        if (isFromHomeActivity){
            categoryArray = Constants.mainCatNameList;

            this.isFromIndex = 99;
        } else {
            if (isFromIndex == 0){
                categoryArray = Constants.gkSubCatNameList;
            } else {
                categoryArray = Constants.reasoningSubCatNameList;
            }
            this.isFromIndex = isFromIndex;
        }
    }

    @Override
    public Holder onCreateViewHolder(ViewGroup parent, int viewType) {
        View v = LayoutInflater.from(parent.getContext()).inflate(R.layout.list_category_item, parent, false);
        return new Holder(v);
    }

    @Override
    public void onBindViewHolder(Holder holder, final int position) {
        holder.categoryText.setText(categoryArray[position]);
        holder.categoryImage.setBackgroundResource(R.drawable.flag);

        holder.maincard.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View v) {
                if (isFromHomeActivity && (position == 0 || position == 1)) {
                    Intent intent = new Intent(context, ChildCategoryListActivity.class);
                    intent.putExtra("cat_index",position);
                    context.startActivity(intent);
                } else {

                    Intent intent = new Intent(context, QuestionAnswerActivity.class);
                    if (isFromIndex == 99){
                        intent.putExtra("cat_index", position);
                    } else {
                        intent.putExtra("cat_index", isFromIndex);
                    }
                    intent.putExtra("sub_cat_index", position);
                    context.startActivity(intent);
                }

            }
        });


    }

    @Override
    public int getItemCount() {
        return categoryArray.length;
    }

    public class Holder extends RecyclerView.ViewHolder {
        private TextView categoryText;
        private ImageView categoryImage,rightTeamImg;
        RelativeLayout maincard;

        public Holder(View itemView) {
            super(itemView);
            categoryText = (TextView) itemView.findViewById(R.id.list_category_title_text);
            categoryImage = (ImageView)itemView.findViewById(R.id.list_category_icon_image);
            maincard = (RelativeLayout) itemView.findViewById(R.id.maincard); //rectview = itemView.findViewById(R.id.rectview);
        }
    }
}
